#include "UKListBox.h"

HINSTANCE g_hInstance;
BOOL g_VelkeIkony = TRUE;

/////////////////////////////////////////////////////////////////////////////
// callback procedura pro funkci SHBrowseForFolder

TCHAR chStartBrowseDir[MAX_PATH];

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TCHAR szDir[MAX_PATH];
	switch ( uMsg )
	{
		case BFFM_INITIALIZED:
			if ( chStartBrowseDir != NULL )
				SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)chStartBrowseDir);
			break;
		case BFFM_SELCHANGED:
			if ( SHGetPathFromIDList((LPITEMIDLIST)lParam, szDir))
				SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)szDir);
			break;
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Vyvol dialog vybrn sloky

BOOL VyberSlozku(LPTSTR lpVybranaSlozka, LPCTSTR lpStart, LPCTSTR lpNadpis, HWND hVlastnik)
{
	if ( lpStart != NULL )
		lstrcpy(chStartBrowseDir, lpStart);
	BOOL bResult = TRUE;
	LPITEMIDLIST pidl	= NULL;
	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);
	if ( IsWindow(hVlastnik) )
		bi.hwndOwner = hVlastnik;
	else
		bi.hwndOwner = NULL;
	bi.pszDisplayName = 0;
	bi.pidlRoot = 0;
	bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
	bi.lpfn = BrowseCallbackProc;
	if ( lpNadpis == NULL )
		bi.lpszTitle = _T("Vyberte poadovanou sloku");
	else
		bi.lpszTitle = lpNadpis;
	pidl= SHBrowseForFolder(&bi);
	if ( pidl )
	{
		if ( !SHGetPathFromIDList(pidl, lpVybranaSlozka) )
			bResult = FALSE;
		pMalloc->Free(pidl);
	}
	else
		bResult = FALSE;
	pMalloc->Release();
	return bResult;
}

void PridatPolozku(HWND hListBox, LPCTSTR lpSoubor)
{
	LRESULT Polozka =
		SendMessage(hListBox, LB_ADDSTRING, 0, (LPARAM)lpSoubor);
	WORD index = 0;
	HICON hIcon = ExtractAssociatedIcon(g_hInstance, (LPTSTR)lpSoubor, &index);
	SendMessage(hListBox, LB_SETITEMDATA, Polozka, (LPARAM)hIcon);
}

void PridatSoubor(HWND hWnd)
{
	TCHAR szSoubor[MAX_PATH];
	lstrcpy(szSoubor, _T(""));
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hWnd;
	ofn.lpstrFile = szSoubor;
	ofn.nMaxFile = sizeof(szSoubor);
	ofn.lpstrFilter = TEXT("Vechny soubory\0*.*\0");
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	if ( !GetOpenFileName(&ofn) ) 
		return;
	PridatPolozku(GetDlgItem(hWnd, IDC_LISTBOX), szSoubor);
}

void DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	TCHAR szSoubor[MAX_PATH];
	HBRUSH hbPozadi;
	SendMessage(lpDIS->hwndItem, LB_GETTEXT, lpDIS->itemID, (LPARAM)szSoubor);
		WORD index = 0;
	int xIkona, yIkona; // rozmry mal nebo velk ikony
	if ( g_VelkeIkony )
	{
		xIkona = GetSystemMetrics(SM_CXICON);
		yIkona = GetSystemMetrics(SM_CYICON);
	}
	else
	{
		xIkona = GetSystemMetrics(SM_CXSMICON);
		yIkona = GetSystemMetrics(SM_CYSMICON);
	}
	HICON hIcon = (HICON)lpDIS->itemData;
	if ( lpDIS->itemState & ODS_SELECTED )
	{
		hbPozadi = GetSysColorBrush(COLOR_HIGHLIGHT);
		SetTextColor(lpDIS->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
	}
	else
	{
		hbPozadi = GetSysColorBrush(COLOR_WINDOW);
		SetTextColor(lpDIS->hDC, GetSysColor(COLOR_WINDOWTEXT));
	}
	
	SetBkMode(lpDIS->hDC, TRANSPARENT);
	FillRect(lpDIS->hDC, &lpDIS->rcItem, hbPozadi);
	
	if ( g_VelkeIkony )
		DrawIcon(lpDIS->hDC,
			lpDIS->rcItem.left+1,
			lpDIS->rcItem.top+1, hIcon);
	else
		DrawIconEx(lpDIS->hDC,
			lpDIS->rcItem.left,
			lpDIS->rcItem.top, hIcon,
			xIkona, yIkona,
			0, NULL, DI_NORMAL);
	RECT rect;
	CopyMemory(&rect, &lpDIS->rcItem, sizeof(RECT));
	rect.left += xIkona + 2;
	LPTSTR  lpSoubor = strrchr(szSoubor, '\\');
	if ( !lpSoubor ) // pro jistotu :))
		lpSoubor = szSoubor;
	else
		lpSoubor++;
	DrawText(lpDIS->hDC, lpSoubor, -1, &rect,
		DT_SINGLELINE | DT_VCENTER);
}


void NastavVelkeIkony(HWND hListBox, BOOL Velke)
{
	g_VelkeIkony = Velke;
	int vyska;
	if ( g_VelkeIkony )
		vyska = GetSystemMetrics(SM_CYICON)+2;
	else
		vyska = GetSystemMetrics(SM_CYSMICON)+2;
	SendMessage(hListBox, LB_SETITEMHEIGHT, 0, (LPARAM)vyska);
	RedrawWindow(hListBox, NULL, NULL,
		RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW );
}

void LBNDblClk(HWND hListBox)
{
	TCHAR szSoubor[MAX_PATH];
	LRESULT Vyber = SendMessage(hListBox, LB_GETCURSEL, 0, 0);
	SendMessage(hListBox, LB_GETTEXT, Vyber,
		(LRESULT)szSoubor);
	ShellExecute(NULL, _T("open"), szSoubor,
		NULL, NULL, SW_SHOWNORMAL);
}

void DropFiles(HWND hWnd, HDROP hDrop)
{
	TCHAR szSoubor[MAX_PATH];
	int Pocet = (int)DragQueryFile(hDrop, 0xFFFFFFFF, NULL, 0);
	if ( Pocet <= 0 )
		return;
	for ( int i = 0; i < Pocet; i++ )
	{
		DragQueryFile(hDrop, i, szSoubor, MAX_PATH);
		PridatPolozku(hWnd, szSoubor);
	}
	DragFinish(hDrop);
}

WNDPROC wndprocLB;

LRESULT CALLBACK WindowProcListBox(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_DROPFILES:
			DropFiles(hWnd,  (HDROP)wParam);
			break;
	}
	return CallWindowProc(wndprocLB,  hWnd, uMsg, wParam, lParam);
}


/////////////////////////////////////////////////////////////////////////////

void PridejZeSlozky(HWND hWnd, LPTSTR lpSlozka)
{
	MessageBox(hWnd, _T("Tohle si ukeme pt"),
		_T("ListBox demo"), MB_ICONINFORMATION);
	// Vklad bude v ptm dle !!
/*	TCHAR szSoubor[MAX_PATH];
	lstrcpy(szSoubor, lpSlozka);
	lstrcat(szSoubor, _T("\\*.*"));
	HWND hListBox = GetDlgItem(hWnd, IDC_LISTBOX);
	WIN32_FIND_DATA wfd;
	ZeroMemory(&wfd, sizeof(wfd));
	HANDLE hFind = FindFirstFile(szSoubor, &wfd);
	if ( hFind == INVALID_HANDLE_VALUE )
		return;
	// Vylouit sloky
	if ( !(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
	{
		lstrcpy(szSoubor, lpSlozka);
		lstrcat(szSoubor, _T("\\"));
		lstrcat(szSoubor, wfd.cFileName);
		PridatPolozku(hListBox, szSoubor);
	}
	while ( FindNextFile(hFind, &wfd) )
	{
		// Vylouit sloky
		if ( !(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) )
		{
			lstrcpy(szSoubor, lpSlozka);
			lstrcat(szSoubor, _T("\\"));
			lstrcat(szSoubor, wfd.cFileName);
			PridatPolozku(hListBox, szSoubor);
		}
	}
	FindClose(hFind);
	*/
}

/////////////////////////////////////////////////////////////////////////////

void PridatSlozku(HWND hWnd)
{
	TCHAR szSlozka[MAX_PATH] = {0};
	if ( !VyberSlozku(szSlozka, szSlozka,	_T("Pidat sloku do ListBoxu"), hWnd) )
		return;
	// Otestujeme, zda je uivatelsky kreslen
	if ( GetWindowLongPtr(GetDlgItem(hWnd, IDC_LISTBOX), GWL_STYLE)
		& (LBS_OWNERDRAWFIXED | LBS_OWNERDRAWVARIABLE) )
		PridejZeSlozky(hWnd, szSlozka);
	else
	{
		lstrcat(szSlozka, _T("\\*.*"));
		SendDlgItemMessage(hWnd, IDC_LISTBOX, LB_DIR, 0,
			(LPARAM)szSlozka);
	}
}

/////////////////////////////////////////////////////////////////////////////
// Procedura dialogu

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LPMEASUREITEMSTRUCT lpMIS;
	switch ( uMsg )
	{
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				case IDC_PRIDAT:
					PridatSoubor(hWnd);
					break;
				case IDC_LISTBOX:
					if ( HIWORD(wParam) == LBN_DBLCLK )
						LBNDblClk((HWND)lParam);
					break;
				case IDC_VELKE_IKONY:
					if ( HIWORD(wParam) == BN_CLICKED )
					{
						NastavVelkeIkony(GetDlgItem(hWnd, IDC_LISTBOX),
							IsDlgButtonChecked(hWnd, IDC_VELKE_IKONY) == BST_CHECKED);
					}
					break;
				case IDC_PRIDAT_SLOZKU:
					PridatSlozku(hWnd);
					break;
			}
			break;
		case WM_INITDIALOG:
			wndprocLB = (WNDPROC)SetWindowLongPtr(GetDlgItem(hWnd, IDC_LISTBOX),
				GWLP_WNDPROC, (LONG_PTR)WindowProcListBox);
			CheckDlgButton(hWnd, IDC_VELKE_IKONY, BST_CHECKED);
			DragAcceptFiles(GetDlgItem(hWnd, IDC_LISTBOX), TRUE);
			SendMessage(hWnd, WM_SETICON, ICON_SMALL,
				(LPARAM)LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_HLAVNI)));
			break;
		case WM_DRAWITEM:
			DrawItem((LPDRAWITEMSTRUCT)lParam);
			break;
		case WM_MEASUREITEM:
			lpMIS = (LPMEASUREITEMSTRUCT)lParam;
			lpMIS->itemHeight = GetSystemMetrics(SM_CYICON) + 2;
			break;
	}
	return FALSE;
}


/////////////////////////////////////////////////////////////////////////////
// Hlavn funkce programu pro Windows

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInstance = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_HLAVNI), NULL, DialogProc);
	return 0;
}
